> For the complete documentation index, see [llms.txt](https://docs.keycloakify.dev/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.keycloakify.dev/release-notes-and-upgrade-instructions/v8-greater-than-v9.md).

# v9

* If it's not already the case you must now use the [`copy-keycloak-resources-to-public` postinstall script](https://github.com/keycloakify/keycloakify-starter/blob/92b20fe74154ef8cf037f4b156eb3b2e5264a074/package.json#L11). (Only in WebPack projects, with Vite it's done automatically by the plugin)!.
* The [`keycloakVersionDefaultAssets`](https://docs.keycloakify.dev/v/v8/build-options#keycloakversiondefaultassets) has been removed in favor of [`loginThemeResourcesFromKeycloakVersion`](https://github.com/keycloakify/docs.keycloakify.dev/blob/changelog/broken-reference/README.md).
* You now must have `mvn` (Maven, `brew install maven`) installed to build your Keycloakify theme. The `bundler` build option has been removed in favor of [doCreateJar](https://github.com/keycloakify/docs.keycloakify.dev/blob/changelog/broken-reference/README.md). (Note that Maven is present by default on the GitHub Action runners). If you are building your theme within Docker [here are the instructions](https://github.com/keycloakify/docs.keycloakify.dev/blob/changelog/broken-reference/README.md).
* The [`extraThemeNames`](https://docs.keycloakify.dev/v/v8/build-options#extrathemenames) build option has been removed, if you have theme variant, simply pass an array to the [themeName option](https://github.com/keycloakify/docs.keycloakify.dev/blob/changelog/broken-reference/README.md).
* Keycloakify now generates two jars `*.jar` and `retrocompat-*.jar`. [You should update your CI](https://github.com/keycloakify/keycloakify-starter/commit/c9aad1406502ba08c654ade4bfa95bf3a6e93830).
  * If you have no Account theme: You can use the `retrocompat-*.jar`, it will work on any Keycloak version.
  * If you have an Account theme:

    * You should use `retrocompat-*.jar` on any Keycloak version prior to 23. [And select `<your theme>_retrocompat` when selecting in the dropdown when selecting your account theme](https://github.com/keycloakify/keycloakify/assets/6702424/bc0c988a-9fc1-4c45-a37a-fcf98b7096af).
    * You should use `*.jar` on Keycloak 23 and up.

    Be aware that Account theme does not work in Keycloak 22 (and only in this version).
* If you where loading your theme into your Keycloak by copy pasting the build\_keycloak/src directly into your Keycloak you can still do that with Keycloak prior to 22 or if you don't have an account theme but if you have an account theme and you are on Keycloak 23 you must follow one of the [official instruction for loading the .jar into Keycloak](https://github.com/keycloakify/docs.keycloakify.dev/blob/changelog/broken-reference/README.md).

\\


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.keycloakify.dev/release-notes-and-upgrade-instructions/v8-greater-than-v9.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
